#!/usr/bin/env php
<?php
/*
 * Ce script recherche les traductions manquantes pour le core de PluXml.
 * La liste des fichiers contrôlés est définie dans la constante FILES.
 * Testé avec PluXml 5.8.2.
 * */

define('ROOT', (basename(dirname(__DIR__)) == 'plugins') ? substr(dirname(__DIR__), 0, -strlen('plugins')) : __DIR__ . '/');
const LANGS = array('de', 'en', 'es', 'it', 'nl', 'oc', 'pl', 'pt', 'ro', 'ru');

const PATTERN = ROOT . 'core/lang/%s/%s.php';
const FILES = array('core', 'admin', 'install', 'update');
$tokens = array();

echo "\e[33mChecking translations in the core of PluXml from french\e[m". PHP_EOL . PHP_EOL;
echo 'Filenames as sources :' . PHP_EOL;
foreach(FILES as $file) {
	$filename = sprintf(PATTERN, 'fr', $file);
	echo $filename . PHP_EOL;
	include $filename;
	$tokens[$file] = array_keys($LANG);
}
echo PHP_EOL;

foreach(LANGS as $lang) {
	echo "\e[32mLanguage: $lang \e[m". PHP_EOL;
	foreach($files as $file) {
		echo 'Filename: ' . $file . '.php : ';
		include sprintf(PATTERN, $lang, $file);
		$diff = array_diff($tokens[$file], array_keys($LANG));
		if(count($diff) > 0) {
			echo "\e[31mmissing\e[m" . PHP_EOL . "\t";
			echo implode(PHP_EOL . "\t", $diff) . PHP_EOL;
		} else {
			echo 'Ok' . PHP_EOL;
		}
	}
	echo PHP_EOL;
}
?>
