<?php
if(!defined('PLX_ROOT')) { exit; }

/*
 * https://www.labnol.org/code/19909-google-translate-api
 * https://www.linguee.com/
 * https://cloud.google.com/translate/docs/basic/translating-text
 * https://mymemory.translated.net/doc/spec.php
 * https://tech.yandex.com/translate/doc/dg/reference/translate-docpage/
 * https://translate.systran.net/translationTools/text?lang=fr
 * https://stackoverflow.com/questions/37667671/is-it-possible-to-access-to-google-translate-api-for-free
 * Reverso
 * */

class kzTranslate extends plxPlugin {
	const TOKEN_LENGTH = 32;
	// for lang/??.php file
	const HEAD = <<< 'HEAD'
<?php
$LANG = array(
HEAD;
	const TAIL = <<< 'TAIL'
);
TAIL;
	const COL_STEP = 100; // Max 100 idioms !
	const TABINDEX_START = 1;
	const GOOGLE_TRANSLATION = 'https://translate.googleapis.com/translate_a/single?client=gtx&sl=#1&tl=#2&dt=t&q=#3';
	const MY_MEMORY_TRANSLATION = 'https://api.mymemory.translated.net/get?q=#3&langpair=#1|#2';

	public function __construct($defaultLang) {

		parent::__construct($defaultLang);
		if(!defined('PLX_ADMIN')) { return; }

		$this->setAdminProfil(PROFIL_ADMIN);
		$this->setAdminMenu($this->getlang('TRANSLATION'), 0, $this->getlang('TITLE'));
	}

	public function get_all_idioms($langs, $folder) {
		$this->idioms = array();
		foreach($langs as $lang) {
			// $filename = substr(__DIR__, 0, -strlen(__CLASS__)) . "$plugName/lang/$lang.php";
			$filename = $folder . '/lang/' . $lang . '.php';
			if(!file_exists($filename)) { continue; }

			include($filename); // declare $LANG array

			foreach($LANG as $idiom=>$translation) {
				if(!empty(trim($translation))) {
					if(!array_key_exists($idiom, $this->idioms)) {
						$this->idioms[$idiom] = array();
					}
					$this->idioms[$idiom][$lang] = $translation;
				}
			}

			unset($LANG);
		}

		foreach($this->idioms as $idiom=>$translations) {
			ksort($this->idioms[$idiom]);
		}

		ksort($this->idioms);
	}

 }
?>
